#ifndef ADC_H_
#define ADC_H_
#include <misc.h>

#define VIEW_WIDTH 300 //!< размер оси Х окна вывода осцилограммы
#define STORAGE_MAX 50 //!< максимальный коэффициент суммирования значений для горизонтальной развертки
#define MEASURING_COUNT (VIEW_WIDTH*STORAGE_MAX) //!< количество измеренных значений сигнала сохраняемых в одном цикле ПДП.

//! функция начальной инициализации железа для измерения входного сигнала.
void initADC(void);

//#define AMPLITUDE_K 5 //!< количество делителей вертикальной развертки
#define STORAGE_K 11 //!< количество делителей горизонтальной развертки

//! структура для горизонтальной развертки со значениями коэффициента суммирования значений, шагом сетки, размерности значений.
typedef struct{
	uint16_t k; //!< коэффициент прореживания
	uint16_t add; //!< коэффициент накопления
	float div; //!< коэффициент амплитуды
	uint8_t step; //!< деление сетки
	uint8_t decimal; //!< количество десятичных разрядов
	char r[8]; //!< размерность значений сетки
}STORAGE;

//! структура для вертикальной развертки со значениями коэффициента суммирования значений, шагом сетки, размерности значений.
/*typedef struct{
	float k; //!< коэффициент умножения
	uint8_t step; //!< деление сетки
	uint8_t decimal; //!< количество десятичных разрядов
	char r[7]; //!< размерность значений сетки
}AMPLITUDE;*/

extern const STORAGE storage[]; //!< массив структур для горизонтальной разверки
//extern const AMPLITUDE amplitude[]; //!< массив структур для вертикальной разверки
extern uint8_t lcd[VIEW_WIDTH]; //!< массив значений координат оси Y для построения осцилограммы
extern uint8_t measure[MEASURING_COUNT*2]; //!< массив для измеренных значений с АЦП1.
extern volatile uint16_t view_count; //!< величина длительности осцилограммы для перерисовки за один цикл
extern volatile uint16_t view_start; //!< начальная точка осцилограммы для перерисовки за один цикл

#endif /* ADC_H_ */
